diff --git a/configs/linux-5.4-ansc/sun300iw1p1.dtsi b/configs/linux-5.4-ansc/sun300iw1p1.dtsi
index ab85aa855..eb9bb5d89 100644
--- a/configs/linux-5.4-ansc/sun300iw1p1.dtsi
+++ b/configs/linux-5.4-ansc/sun300iw1p1.dtsi
@@ -1694,6 +1694,7 @@
 			soundcard-mach,codec {
 			};
 		};
+
 		soc_pmu0: soc_pmu0@4A000800 {
 			compatible = "sunxi-soc-pmu,V821";
 			device_type = "sunxi-soc-pmu";
@@ -1708,9 +1709,8 @@
 			};
 		};
 
-		lcd_fb0: lcd_fb0@0 {
-			compatible = "allwinner,sunxi-lcd_fb0";
-			pinctrl-names = "active","sleep";
+		lcd_fb: lcd_fb {
+			compatible = "allwinner,lcd-fb";
 			status = "disabled";
 		};
 
diff --git a/drivers/video/sunxi/Kconfig b/drivers/video/sunxi/Kconfig
index 667ee42f2..84995e433 100644
--- a/drivers/video/sunxi/Kconfig
+++ b/drivers/video/sunxi/Kconfig
@@ -282,42 +282,18 @@ config DISP2_LCD_ESD_DETECT
 	  This enable lcd  esd detect and panel reset for display driver. User must
 	  define panel_reset and esd_check function.
 
-config LCD_FB
-	tristate "Framebuffer implementaion without display hardware of AW"
-#	depends on (ARCH_SUNXI)
-	select FB_CFB_FILLRECT
-	select FB_CFB_COPYAREA
-	select FB_CFB_IMAGEBLIT
-	select BACKLIGHT_CLASS_DEVICE
-	default n
-	help
-	  Framebuffer implementaion for LCD panel without DE and tcon
-
-config LCD_FB_ENABLE_DEFERRED_IO
-	bool "Enable LCD_FB FB_DEFERRED_IO"
-	select FB_DEFERRED_IO
-	default n
-	help
-	  Enable linux framebuffer FB_DEFERRED_IO for LCD_FB
-
 config TV_DECODER_DISPLAY
     tristate "Enable driver of decoder display"
 	default n
 	help
 	  Enable driver of decoder display
 
-menu "LCD panels select"
+menu "LCD Panels select"
 	depends on AW_DISP2
 
 source "$(BSP_TOP)drivers/video/sunxi/disp2/disp/lcd/Kconfig"
 endmenu
 
-menu "LCD fb panels select"
-	depends on LCD_FB
-
-source "$(BSP_TOP)drivers/video/sunxi/lcd_fb/panels/Kconfig"
-endmenu
-
 menu "Display engine feature select"
 	depends on AW_DISP2
 
@@ -337,5 +313,6 @@ config AW_KSC_ENABLE_DMA_HEAP_MEM
 	help
 	  Enable using DMA HEAP memory as internal framebuffer of KSC
 
+source "$(BSP_TOP)drivers/video/sunxi/lcd_fb/Kconfig"
 
 endmenu
diff --git a/drivers/video/sunxi/lcd_fb/Kconfig b/drivers/video/sunxi/lcd_fb/Kconfig
new file mode 100644
index 000000000..c3fd5aa64
--- /dev/null
+++ b/drivers/video/sunxi/lcd_fb/Kconfig
@@ -0,0 +1,35 @@
+# SPDX-License-Identifier: GPL-2.0-or-later
+#
+# SPI LCD Video configuration for sunxi platform
+#
+
+menu "SPI LCD Panel Drivers"
+	depends on FB
+	depends on AW_BSP
+
+config LCD_FB
+	tristate "LCD FB Driver Support (SPI LCD)"
+	depends on (AW_SPI_NG || AW_SPI)
+	select FB_CFB_FILLRECT
+	select FB_CFB_COPYAREA
+	select FB_CFB_IMAGEBLIT
+	select BACKLIGHT_CLASS_DEVICE
+	default n
+	help
+	  Framebuffer implementaion for LCD panel without DE and tcon
+
+config LCD_FB_ENABLE_DEFERRED_IO
+	bool "Enable LCD_FB FB_DEFERRED_IO"
+	depends on LCD_FB
+	select FB_DEFERRED_IO
+	default n
+	help
+	  Enable linux framebuffer FB_DEFERRED_IO for LCD_FB
+
+menu "LCD FB Panels select"
+	depends on LCD_FB
+source "$(BSP_TOP)drivers/video/sunxi/lcd_fb/panels/Kconfig"
+endmenu
+
+endmenu
+
diff --git a/drivers/video/sunxi/lcd_fb/Makefile b/drivers/video/sunxi/lcd_fb/Makefile
index 3fb97678f..9aca80a78 100644
--- a/drivers/video/sunxi/lcd_fb/Makefile
+++ b/drivers/video/sunxi/lcd_fb/Makefile
@@ -1,9 +1,16 @@
 # SPDX-License-Identifier: GPL-2.0
 obj-$(CONFIG_LCD_FB) += lcd_fb.o
+obj-$(CONFIG_LCD_FB) += lcd_fb_spi_panel.o
 
 lcd_fb-objs := dev_lcd_fb.o disp_lcd.o dev_fb.o logo.o
-lcd_fb-objs += lcd_fb_intf.o disp_display.o panels/panels.o panels/lcd_source.o
+lcd_fb-objs += lcd_fb_intf.o disp_display.o panels/panels.o
+
+lcd_fb_spi_panel-objs += panels/spi_panel.o
+
+# LCD Panel Driver
 lcd_fb-${CONFIG_LCD_SUPPORT_KLD35512} += panels/kld35512.o
 lcd_fb-${CONFIG_LCD_SUPPORT_KLD39501} += panels/kld39501.o
 lcd_fb-${CONFIG_LCD_SUPPORT_KLD2844B} += panels/kld2844b.o
 lcd_fb-${CONFIG_LCD_SUPPORT_NV3029S} += panels/nv3029s.o
+lcd_fb-${CONFIG_LCD_SUPPORT_ST77916_QSPI} += panels/st77916.o
+
diff --git a/drivers/video/sunxi/lcd_fb/dev_fb.c b/drivers/video/sunxi/lcd_fb/dev_fb.c
index 0668ad332..cbbf6afa7 100644
--- a/drivers/video/sunxi/lcd_fb/dev_fb.c
+++ b/drivers/video/sunxi/lcd_fb/dev_fb.c
@@ -1,4 +1,4 @@
-/* SPDX-License-Identifier: GPL-2.0-or-later */
+// SPDX-License-Identifier: GPL-2.0-or-later
 /* Copyright(c) 2020 - 2023 Allwinner Technology Co.,Ltd. All rights reserved. */
 /*
  * dev_fb/dev_fb.c
@@ -25,54 +25,57 @@
 #define dma_mmap_writecombine dma_mmap_wc
 #endif
 
-struct fb_info_t {
+struct lcd_fb_info {
+	u32 fb_count;
 	struct device *dev;
-	bool fb_enable[LCD_FB_MAX];
-	struct fb_info *fbinfo[LCD_FB_MAX];
-	int blank[LCD_FB_MAX];
-	int fb_index[LCD_FB_MAX];
-	u32 pseudo_palette[LCD_FB_MAX][16];
+	bool *fb_enable;
+	struct fb_info **fbinfo;
+	int *blank;
+	int *fb_index;
+	u32 **pseudo_palette;
 };
 
-static struct fb_info_t g_fbi;
+static struct lcd_fb_info g_fbi;
 
-static int lcd_fb_open(struct fb_info *info, int user)
+static int sunxi_lcd_fb_open(struct fb_info *info, int user)
 {
 	return 0;
 }
-static int lcd_fb_release(struct fb_info *info, int user)
+
+static int sunxi_lcd_fb_release(struct fb_info *info, int user)
 {
 	return 0;
 }
 
-void lcd_fb_black_screen(u32 sel)
+void sunxi_lcd_fb_black_screen(u32 sel)
 {
-	if (sel >= LCD_FB_MAX) {
-		lcd_fb_wrn("Exceed max fb:%d >= %d\n", sel, LCD_FB_MAX);
+	if (sel >= g_drv_info.lcd_panel_count) {
+		LCDFB_WRN("Exceed max fb:%d >= %d\n", sel,
+			  g_drv_info.lcd_panel_count);
 		return;
 	}
 
-	bsp_disp_lcd_set_layer(sel, g_fbi.fbinfo[sel]);
+	sunxi_lcd_fb_bsp_disp_lcd_set_layer(sel, g_fbi.fbinfo[sel]);
 }
 
-static int lcd_fb_pan_display(struct fb_var_screeninfo *var,
-				struct fb_info *info)
+static int sunxi_lcd_fb_pan_display(struct fb_var_screeninfo *var,
+				    struct fb_info *info)
 {
 	u32 sel = 0;
 	struct fb_info tmp_info;
 	memcpy(&tmp_info, info, sizeof(tmp_info));
 	memcpy(&tmp_info.var, var, sizeof(tmp_info.var));
 
-	for (sel = 0; sel < LCD_FB_MAX; sel++) {
+	for (sel = 0; sel < g_drv_info.lcd_panel_count; sel++) {
 		if (sel == g_fbi.fb_index[info->node]) {
-			bsp_disp_lcd_set_layer(sel, &tmp_info);
-			bsp_disp_lcd_wait_for_vsync(sel);
+			sunxi_lcd_fb_bsp_disp_lcd_set_layer(sel, &tmp_info);
+			sunxi_lcd_fb_bsp_disp_lcd_wait_for_vsync(sel);
 		}
 	}
 	return 0;
 }
 
-static int lcd_fb_mmap(struct fb_info *info, struct vm_area_struct *vma)
+static int sunxi_lcd_fb_mmap(struct fb_info *info, struct vm_area_struct *vma)
 {
 	unsigned int offset = vma->vm_pgoff << PAGE_SHIFT;
 
@@ -85,34 +88,34 @@ static int lcd_fb_mmap(struct fb_info *info, struct vm_area_struct *vma)
 	return -EINVAL;
 }
 
-static int lcd_fb_set_par(struct fb_info *info)
+static int sunxi_lcd_fb_set_par(struct fb_info *info)
 {
-	return bsp_disp_lcd_set_var(info->node, info);
+	return sunxi_lcd_fb_bsp_disp_lcd_set_var(info->node, info);
 }
 
-static int lcd_fb_check_var(struct fb_var_screeninfo *var,
-			      struct fb_info *info)
+static int sunxi_lcd_fb_check_var(struct fb_var_screeninfo *var,
+				  struct fb_info *info)
 {
 	return 0;
 }
-static int lcd_fb_blank(int blank_mode, struct fb_info *info)
+static int sunxi_lcd_fb_blank(int blank_mode, struct fb_info *info)
 {
 	if (blank_mode == FB_BLANK_POWERDOWN)
-		return bsp_disp_lcd_blank(info->node, 1);
+		return sunxi_lcd_fb_bsp_disp_lcd_blank(info->node, 1);
 	else
-		return bsp_disp_lcd_blank(info->node, 0);
+		return sunxi_lcd_fb_bsp_disp_lcd_blank(info->node, 0);
 }
 
-static inline u32 convert_bitfield(int val, struct fb_bitfield *bf)
+static inline u32 sunxi_lcd_fb_convert_bitfield(int val, struct fb_bitfield *bf)
 {
 	u32 mask = ((1 << bf->length) - 1) << bf->offset;
 
 	return (val << bf->offset) & mask;
 }
 
-static int lcd_fb_setcolreg(unsigned regno, unsigned red, unsigned green,
-			      unsigned blue, unsigned transp,
-			      struct fb_info *info)
+static int sunxi_lcd_fb_setcolreg(unsigned regno, unsigned red, unsigned green,
+				  unsigned blue, unsigned transp,
+				  struct fb_info *info)
 {
 	u32 val;
 	u32 ret = 0;
@@ -123,11 +126,15 @@ static int lcd_fb_setcolreg(unsigned regno, unsigned red, unsigned green,
 		break;
 	case FB_VISUAL_TRUECOLOR:
 		if (regno < 16) {
-			val = convert_bitfield(transp, &info->var.transp) |
-			    convert_bitfield(red, &info->var.red) |
-			    convert_bitfield(green, &info->var.green) |
-			    convert_bitfield(blue, &info->var.blue);
-			((u32 *) info->pseudo_palette)[regno] = val;
+			val = sunxi_lcd_fb_convert_bitfield(transp,
+							    &info->var.transp) |
+			      sunxi_lcd_fb_convert_bitfield(red,
+							    &info->var.red) |
+			      sunxi_lcd_fb_convert_bitfield(green,
+							    &info->var.green) |
+			      sunxi_lcd_fb_convert_bitfield(blue,
+							    &info->var.blue);
+			((u32 *)info->pseudo_palette)[regno] = val;
 		} else {
 			ret = 0;
 		}
@@ -140,13 +147,12 @@ static int lcd_fb_setcolreg(unsigned regno, unsigned red, unsigned green,
 	return ret;
 }
 
-static int lcd_fb_setcmap(struct fb_cmap *cmap, struct fb_info *info)
+static int sunxi_lcd_fb_setcmap(struct fb_cmap *cmap, struct fb_info *info)
 {
 	unsigned int j, r = 0;
 	unsigned char hred, hgreen, hblue, htransp = 0xff;
 	unsigned short *red, *green, *blue, *transp;
 
-
 	red = cmap->red;
 	green = cmap->green;
 	blue = cmap->blue;
@@ -161,8 +167,8 @@ static int lcd_fb_setcmap(struct fb_cmap *cmap, struct fb_info *info)
 		else
 			htransp = 0xff;
 
-		r = lcd_fb_setcolreg(cmap->start + j, hred, hgreen, hblue,
-				       htransp, info);
+		r = sunxi_lcd_fb_setcolreg(cmap->start + j, hred, hgreen, hblue,
+					   htransp, info);
 		if (r)
 			return r;
 	}
@@ -172,27 +178,27 @@ static int lcd_fb_setcmap(struct fb_cmap *cmap, struct fb_info *info)
 
 static struct fb_ops lcdfb_ops = {
 	.owner = THIS_MODULE,
-	.fb_open = lcd_fb_open,
-	.fb_release = lcd_fb_release,
-	.fb_pan_display = lcd_fb_pan_display,
+	.fb_open = sunxi_lcd_fb_open,
+	.fb_release = sunxi_lcd_fb_release,
+	.fb_pan_display = sunxi_lcd_fb_pan_display,
 	/* .fb_ioctl = lcd_fb_ioctl, */
-	.fb_check_var = lcd_fb_check_var,
-	.fb_set_par = lcd_fb_set_par,
-	.fb_blank = lcd_fb_blank,
+	.fb_check_var = sunxi_lcd_fb_check_var,
+	.fb_set_par = sunxi_lcd_fb_set_par,
+	.fb_blank = sunxi_lcd_fb_blank,
 	/* .fb_cursor = lcd_fb_cursor, */
-	.fb_mmap = lcd_fb_mmap,
+	.fb_mmap = sunxi_lcd_fb_mmap,
 #if IS_ENABLED(CONFIG_AW_FB_CONSOLE)
 	.fb_fillrect = cfb_fillrect,
 	.fb_copyarea = cfb_copyarea,
 	.fb_imageblit = cfb_imageblit,
 #endif
-	.fb_setcmap = lcd_fb_setcmap,
-	.fb_setcolreg = lcd_fb_setcolreg,
-
+	.fb_setcmap = sunxi_lcd_fb_setcmap,
+	.fb_setcolreg = sunxi_lcd_fb_setcolreg,
 };
 
-static s32 pixel_format_to_var(enum lcdfb_pixel_format format,
-			  struct fb_var_screeninfo *var)
+static s32
+sunxi_lcd_fb_pixel_format_to_var(enum sunxi_lcd_fb_pixel_format format,
+				 struct fb_var_screeninfo *var)
 {
 	switch (format) {
 	case LCDFB_FORMAT_ARGB_8888:
@@ -284,90 +290,106 @@ static s32 pixel_format_to_var(enum lcdfb_pixel_format format,
 
 		break;
 	default:
-		lcd_fb_wrn("[FB]not support format %d\n", format);
+		LCDFB_WRN("[FB]not support format %d\n", format);
 	}
 
-	lcd_fb_inf
-	    ("fmt%d para: %dbpp, a(%d,%d),r(%d,%d),g(%d,%d),b(%d,%d)\n",
-	     (int)format, (int)var->bits_per_pixel, (int)var->transp.offset,
-	     (int)var->transp.length, (int)var->red.offset,
-	     (int)var->red.length, (int)var->green.offset,
-	     (int)var->green.length, (int)var->blue.offset,
-	     (int)var->blue.length);
+	LCDFB_INF("fmt%d para: %dbpp, a(%d,%d),r(%d,%d),g(%d,%d),b(%d,%d)\n",
+		  (int)format, (int)var->bits_per_pixel,
+		  (int)var->transp.offset, (int)var->transp.length,
+		  (int)var->red.offset, (int)var->red.length,
+		  (int)var->green.offset, (int)var->green.length,
+		  (int)var->blue.offset, (int)var->blue.length);
 
 	return 0;
 }
 
-static int fb_map_video_memory(struct fb_info *info)
+static int sunxi_lcd_fb_map_video_memory(struct fb_info *info)
 {
 	unsigned long long phy_addr = 0;
-	info->screen_base =
-	    (char __iomem *)lcd_fb_dma_malloc(info->fix.smem_len,
-					(u32 *) (&phy_addr));
+	info->screen_base = (char __iomem *)sunxi_lcd_fb_dma_malloc(
+		info->fix.smem_len, (u32 *)(&phy_addr));
 	info->fix.smem_start = (unsigned long)phy_addr;
 
 	if (info->screen_base) {
-		lcd_fb_inf("%s(reserve),va=0x%p, pa=0x%p size:0x%x\n", __func__,
-		      (void *)info->screen_base,
-		      (void *)info->fix.smem_start,
-		      (unsigned int)info->fix.smem_len);
+		LCDFB_INF("%s(reserve),va=0x%p, pa=0x%p size:0x%x\n", __func__,
+			  (void *)info->screen_base,
+			  (void *)info->fix.smem_start,
+			  (unsigned int)info->fix.smem_len);
 		memset((void *__force)info->screen_base, 0x0,
 		       info->fix.smem_len);
 
-
 		return 0;
 	}
 
-	lcd_fb_wrn("%s fail!\n", __func__);
+	LCDFB_WRN("%s fail!\n", __func__);
 	return -ENOMEM;
-
-	return 0;
 }
 
-static inline void fb_unmap_video_memory(struct fb_info *info)
+static void sunxi_lcd_fb_unmap_video_memory(struct fb_info *info)
 {
 	if (!info->screen_base) {
-		lcd_fb_wrn("%s: screen_base is null\n", __func__);
+		LCDFB_WRN("%s: screen_base is null\n", __func__);
 		return;
 	}
-	lcd_fb_inf("%s: screen_base=0x%p, smem=0x%p, len=0x%x\n", __func__,
-	      (void *)info->screen_base,
-	      (void *)info->fix.smem_start, info->fix.smem_len);
-	lcd_fb_dma_free((void *__force)info->screen_base,
-		  (void *)info->fix.smem_start, info->fix.smem_len);
+	LCDFB_INF("%s: screen_base=0x%p, smem=0x%p, len=0x%x\n", __func__,
+		  (void *)info->screen_base, (void *)info->fix.smem_start,
+		  info->fix.smem_len);
+	sunxi_lcd_fb_dma_free((void *__force)info->screen_base,
+			      (void *)info->fix.smem_start, info->fix.smem_len);
 	info->screen_base = 0;
 	info->fix.smem_start = 0;
 }
 
-#ifdef CONFIG_FB_DEFERRED_IO
-static void lcdfb_deferred_io(struct fb_info *info, struct list_head *pagelist)
+#if IS_ENABLED(CONFIG_FB_DEFERRED_IO)
+static void sunxi_lcd_fb_deferred_io(struct fb_info *info,
+				     struct list_head *pagelist)
 {
 	u32 sel = 0;
-	for (sel = 0; sel < LCD_FB_MAX; sel++) {
+	for (sel = 0; sel < g_drv_info.lcd_panel_count; sel++) {
 		if (sel == g_fbi.fb_index[info->node]) {
-			bsp_disp_lcd_set_layer(sel, g_fbi.fbinfo[sel]);
+			sunxi_lcd_fb_bsp_disp_lcd_set_layer(sel,
+							    g_fbi.fbinfo[sel]);
 		}
 	}
-
 }
 #endif
 
-int fb_init(struct dev_lcd_fb_t *p_info)
+int sunxi_lcd_fb_init(struct sunxi_lcd_fb_dev_lcd_fb_t *p_info)
 {
 	int i = 0, buffer_num = 2, pixel_format = 0;
-	struct disp_panel_para info;
-#ifdef CONFIG_FB_DEFERRED_IO
+	struct sunxi_lcd_fb_disp_panel_para info;
+#if IS_ENABLED(CONFIG_FB_DEFERRED_IO)
 	struct fb_deferred_io *fbdefio = NULL;
 #endif
 
 	g_fbi.dev = p_info->device;
 
-	if (p_info->lcd_fb_num > LCD_FB_MAX) {
-		lcd_fb_wrn("Only %d fb devices is support\n", LCD_FB_MAX);
+	if (p_info->lcd_fb_num > g_drv_info.lcd_panel_count) {
+		LCDFB_WRN("Only %d fb devices are supported\n", g_drv_info.lcd_panel_count);
 		return -1;
 	}
+
+	g_fbi.fbinfo = kmalloc(sizeof(struct fb_info *) * p_info->lcd_fb_num,
+			       GFP_KERNEL);
+	if (!g_fbi.fbinfo) {
+		return -ENOMEM;
+	}
+
+	g_fbi.fb_enable =
+		kmalloc(sizeof(bool) * p_info->lcd_fb_num, GFP_KERNEL);
+	g_fbi.fb_index = kmalloc(sizeof(int) * p_info->lcd_fb_num, GFP_KERNEL);
+	g_fbi.pseudo_palette =
+		kmalloc(sizeof(u32 *) * p_info->lcd_fb_num, GFP_KERNEL);
+	if (!g_fbi.fb_enable || !g_fbi.fb_index || !g_fbi.pseudo_palette) {
+		return -ENOMEM;
+	}
+
 	for (i = 0; i < p_info->lcd_fb_num; i++) {
 		g_fbi.fbinfo[i] = framebuffer_alloc(0, g_fbi.dev);
+		if (!g_fbi.fbinfo[i]) {
+			return -ENOMEM;
+		}
+
 		g_fbi.fbinfo[i]->fbops = &lcdfb_ops;
 		g_fbi.fbinfo[i]->flags = 0;
 		g_fbi.fbinfo[i]->device = g_fbi.dev;
@@ -397,10 +419,10 @@ int fb_init(struct dev_lcd_fb_t *p_info)
 		g_fbi.fbinfo[i]->fix.ywrapstep = 0;
 		g_fbi.fbinfo[i]->fix.accel = FB_ACCEL_NONE;
 		g_fbi.fbinfo[i]->fix.line_length =
-		    g_fbi.fbinfo[i]->var.xres_virtual * 4;
+			g_fbi.fbinfo[i]->var.xres_virtual * 4;
 		g_fbi.fbinfo[i]->fix.smem_len =
-		    g_fbi.fbinfo[i]->fix.line_length *
-		    g_fbi.fbinfo[i]->var.yres_virtual * 2;
+			g_fbi.fbinfo[i]->fix.line_length *
+			g_fbi.fbinfo[i]->var.yres_virtual * 2;
 		g_fbi.fbinfo[i]->screen_base = NULL;
 		g_fbi.fbinfo[i]->pseudo_palette = g_fbi.pseudo_palette[i];
 		g_fbi.fbinfo[i]->fix.smem_start = 0x0;
@@ -412,73 +434,84 @@ int fb_init(struct dev_lcd_fb_t *p_info)
 		buffer_num = 2;
 		pixel_format = LCDFB_FORMAT_ARGB_8888;
 		memset(&info, 0, sizeof(info));
-		if (!bsp_disp_get_panel_info(i, &info)) {
+		if (!sunxi_lcd_fb_bsp_disp_get_panel_info(i, &info)) {
 			buffer_num = info.fb_buffer_num;
 			pixel_format = info.lcd_pixel_fmt;
 		}
 
-#ifdef CONFIG_FB_DEFERRED_IO
+#if IS_ENABLED(CONFIG_FB_DEFERRED_IO)
 		fbdefio = NULL;
 		fbdefio = devm_kzalloc(g_fbi.dev, sizeof(*fbdefio), GFP_KERNEL);
 		if (!fbdefio)
 			return -1;
 		g_fbi.fbinfo[i]->fbdefio = fbdefio;
-		fbdefio->delay =           HZ/info.lcd_fps;
-		fbdefio->deferred_io =     lcdfb_deferred_io;
+		fbdefio->delay = HZ / info.lcd_fps;
+		fbdefio->deferred_io = sunxi_lcd_fb_deferred_io;
 		fb_deferred_io_init(g_fbi.fbinfo[i]);
 #endif
 
-		pixel_format_to_var(pixel_format,
-			       &(g_fbi.fbinfo[i]->var));
+		sunxi_lcd_fb_pixel_format_to_var(pixel_format,
+						 &(g_fbi.fbinfo[i]->var));
 
 		g_fbi.fbinfo[i]->var.xoffset = 0;
 		g_fbi.fbinfo[i]->var.yoffset = 0;
-		g_fbi.fbinfo[i]->var.xres = bsp_disp_get_screen_width(i);
-		g_fbi.fbinfo[i]->var.yres = bsp_disp_get_screen_height(i);
-		g_fbi.fbinfo[i]->var.xres_virtual = bsp_disp_get_screen_width(i);
+		g_fbi.fbinfo[i]->var.xres =
+			sunxi_lcd_fb_bsp_disp_get_screen_width(i);
+		g_fbi.fbinfo[i]->var.yres =
+			sunxi_lcd_fb_bsp_disp_get_screen_height(i);
+		g_fbi.fbinfo[i]->var.xres_virtual =
+			sunxi_lcd_fb_bsp_disp_get_screen_width(i);
 		g_fbi.fbinfo[i]->fix.line_length =
-		    (g_fbi.fbinfo[i]->var.xres * g_fbi.fbinfo[i]->var.bits_per_pixel) >> 3;
+			(g_fbi.fbinfo[i]->var.xres *
+			 g_fbi.fbinfo[i]->var.bits_per_pixel) >>
+			3;
 
 		g_fbi.fbinfo[i]->fix.smem_len =
-			g_fbi.fbinfo[i]->fix.line_length * g_fbi.fbinfo[i]->var.yres * buffer_num;
+			g_fbi.fbinfo[i]->fix.line_length *
+			g_fbi.fbinfo[i]->var.yres * buffer_num;
 
 		if (g_fbi.fbinfo[i]->fix.line_length != 0)
 			g_fbi.fbinfo[i]->var.yres_virtual =
-				g_fbi.fbinfo[i]->fix.smem_len / g_fbi.fbinfo[i]->fix.line_length;
-		fb_map_video_memory(g_fbi.fbinfo[i]);
-
-		/* TODO:set fb timing */
+				g_fbi.fbinfo[i]->fix.smem_len /
+				g_fbi.fbinfo[i]->fix.line_length;
+		sunxi_lcd_fb_map_video_memory(g_fbi.fbinfo[i]);
 
+		/* set fb timing */
 		g_fbi.fbinfo[i]->var.width =
-			bsp_disp_get_screen_physical_width(i);
+			sunxi_lcd_fb_bsp_disp_get_screen_physical_width(i);
 		g_fbi.fbinfo[i]->var.height =
-			bsp_disp_get_screen_physical_height(i);
+			sunxi_lcd_fb_bsp_disp_get_screen_physical_height(i);
+
+		/* enable display */
 		g_fbi.fb_enable[i] = 1;
-		/* TODO:display something? */
 		g_fbi.fb_index[i] = i;
 		register_framebuffer(g_fbi.fbinfo[i]);
-		logo_parse(g_fbi.fbinfo[i]);
+		sunxi_lcd_fb_logo_parse(g_fbi.fbinfo[i]);
 	}
 
 	return 0;
 }
 
-int fb_exit(void)
+int sunxi_lcd_fb_exit(void)
 {
 	unsigned int fb_id = 0;
 
-	for (fb_id = 0; fb_id < LCD_FB_MAX; fb_id++) {
+	for (fb_id = 0; fb_id < g_drv_info.lcd_panel_count; fb_id++) {
 		if (g_fbi.fbinfo[fb_id]) {
-#ifdef CONFIG_FB_DEFERRED_IO
+#if IS_ENABLED(CONFIG_FB_DEFERRED_IO)
 			fb_deferred_io_cleanup(g_fbi.fbinfo[fb_id]);
 #endif
 			fb_dealloc_cmap(&g_fbi.fbinfo[fb_id]->cmap);
-			fb_unmap_video_memory(g_fbi.fbinfo[fb_id]);
+			sunxi_lcd_fb_unmap_video_memory(g_fbi.fbinfo[fb_id]);
 			unregister_framebuffer(g_fbi.fbinfo[fb_id]);
 			framebuffer_release(g_fbi.fbinfo[fb_id]);
 			g_fbi.fbinfo[fb_id] = NULL;
 		}
 	}
 
+	kfree(g_fbi.fbinfo);
+	kfree(g_fbi.fb_enable);
+	kfree(g_fbi.fb_index);
+	kfree(g_fbi.pseudo_palette);
 	return 0;
 }
diff --git a/drivers/video/sunxi/lcd_fb/dev_fb.h b/drivers/video/sunxi/lcd_fb/dev_fb.h
index 24af20f50..6d2728ed7 100644
--- a/drivers/video/sunxi/lcd_fb/dev_fb.h
+++ b/drivers/video/sunxi/lcd_fb/dev_fb.h
@@ -1,4 +1,4 @@
-/* SPDX-License-Identifier: GPL-2.0-or-later */
+// SPDX-License-Identifier: GPL-2.0-or-later
 /* Copyright(c) 2020 - 2023 Allwinner Technology Co.,Ltd. All rights reserved. */
 /*
  * Copyright (c) 2007-2019 Allwinnertech Co., Ltd.
@@ -19,8 +19,10 @@
 
 #include "dev_lcd_fb.h"
 
-int fb_init(struct dev_lcd_fb_t *p_info);
-int fb_exit(void);
-void lcd_fb_black_screen(u32 sel);
+int sunxi_lcd_fb_init(struct sunxi_lcd_fb_dev_lcd_fb_t *p_info);
+
+int sunxi_lcd_fb_exit(void);
+
+void sunxi_lcd_fb_black_screen(u32 sel);
 
 #endif /* End of file */
diff --git a/drivers/video/sunxi/lcd_fb/dev_lcd_fb.c b/drivers/video/sunxi/lcd_fb/dev_lcd_fb.c
index ea9129cf0..e7db39c4c 100644
--- a/drivers/video/sunxi/lcd_fb/dev_lcd_fb.c
+++ b/drivers/video/sunxi/lcd_fb/dev_lcd_fb.c
@@ -1,4 +1,4 @@
-/* SPDX-License-Identifier: GPL-2.0-or-later */
+// SPDX-License-Identifier: GPL-2.0-or-later
 /* Copyright(c) 2020 - 2023 Allwinner Technology Co.,Ltd. All rights reserved. */
 /*
  * Copyright (c) 2007-2019 Allwinnertech Co., Ltd.
@@ -15,183 +15,221 @@
  *
  */
 #include "include.h"
-#include "./panels/panels.h"
+
 #include "disp_lcd.h"
 #include "disp_display.h"
 #include "dev_fb.h"
 #include "dev_lcd_fb.h"
 
-struct dev_lcd_fb_t g_drv_info;
-
-
-extern int lcd_init(void);
-
+#include "./panels/panels.h"
 
+struct sunxi_lcd_fb_dev_lcd_fb_t g_drv_info;
 
-static struct attribute *lcd_fb_attributes[] = {
-	NULL
-};
+static struct attribute *lcd_fb_attributes[] = { NULL };
 
 static struct attribute_group lcd_fb_attribute_group = {
 	.name = "attr",
 	.attrs = lcd_fb_attributes
 };
 
-static void start_work(struct work_struct *work)
+static void sunxi_lcd_fb_module_start_work(struct work_struct *work)
 {
 	int i = 0;
-	struct lcd_fb_device *dispdev = NULL;
+	struct sunxi_lcd_fb_device *dispdev = NULL;
 
-	for (i = 0; i < SUPPORT_MAX_LCD; ++i) {
-		dispdev = lcd_fb_device_get(i);
+	for (i = 0; i < g_drv_info.lcd_panel_count; ++i) {
+		dispdev = sunxi_sunxi_lcd_fb_device_get(i);
 		if (dispdev)
 			dispdev->enable(dispdev);
 	}
-
 }
 
-static s32 start_process(void)
+static s32 sunxi_lcd_fb_module_start_process(void)
 {
 	flush_work(&g_drv_info.start_work);
 	schedule_work(&g_drv_info.start_work);
 	return 0;
 }
 
-static int lcd_fb_probe(struct platform_device *pdev)
+static int sunxi_lcd_fb_module_probe(struct platform_device *pdev)
 {
 	int ret = 0;
+	struct device_node *np = pdev->dev.of_node;
+
+	LCDFB_DBG("running sunxi_lcd_fb_module_probe\n");
 
 	g_drv_info.device = &pdev->dev;
-	lcd_fb_wrn("\n");
+
 	ret = sysfs_create_group(&pdev->dev.kobj, &lcd_fb_attribute_group);
-	INIT_WORK(&g_drv_info.start_work, start_work);
 
-	disp_init_lcd(&g_drv_info);
+	INIT_WORK(&g_drv_info.start_work, sunxi_lcd_fb_module_start_work);
+
+	g_drv_info.lcd_panel_count = of_graph_get_endpoint_count(np);
+	if (g_drv_info.lcd_panel_count <= 0) {
+		LCDFB_WRN("no endpoints found for node\n");
+		return -ENODEV;
+	}
+
+	LCDFB_DBG("get endpoint count %d\n", g_drv_info.lcd_panel_count);
+
+	sunxi_lcd_fb_disp_init_lcd(&g_drv_info);
+
+	if (!g_drv_info.lcd_fb_num) {
+		LCDFB_WRN("no panel found for lcd fb\n");
+		return -ENODEV;
+	}
 
-	lcd_init();
+	sunxi_lcd_fb_lcd_panel_init();
 
-	fb_init(&g_drv_info);
+	sunxi_lcd_fb_init(&g_drv_info);
+
+	sunxi_lcd_fb_module_start_process();
 
-	start_process();
 	return ret;
 }
 
-static void lcd_fb_shutdown(struct platform_device *pdev)
+static void sunxi_lcd_fb_module_shutdown(struct platform_device *pdev)
 {
 	int i = 0;
-	struct lcd_fb_device *dispdev = NULL;
+	struct sunxi_lcd_fb_device *dispdev = NULL;
 
-	for (i = 0; i < SUPPORT_MAX_LCD; ++i) {
-		dispdev = lcd_fb_device_get(i);
+	for (i = 0; i < g_drv_info.lcd_panel_count; ++i) {
+		dispdev = sunxi_sunxi_lcd_fb_device_get(i);
 		if (dispdev)
 			dispdev->disable(dispdev);
 	}
-	lcd_fb_wrn("Finish\n");
+
+	LCDFB_DBG("running sunxi_lcd_fb_module_shutdown\n");
 }
 
-static int lcd_fb_remove(struct platform_device *pdev)
+static int sunxi_lcd_fb_module_remove(struct platform_device *pdev)
 {
-	int ret = 0;
+	sunxi_lcd_fb_module_shutdown(pdev);
+
+	sunxi_lcd_fb_exit();
+
+	sunxi_lcd_fb_disp_exit_lcd();
 
-	lcd_fb_shutdown(pdev);
-	fb_exit();
-	disp_exit_lcd();
 	sysfs_remove_group(&pdev->dev.kobj, &lcd_fb_attribute_group);
+
 	platform_set_drvdata(pdev, NULL);
-	return ret;
-}
 
+	LCDFB_DBG("running sunxi_lcd_fb_module_remove\n");
 
-static const struct of_device_id lcd_fb_match[] = {
-	{.compatible = "allwinner,sunxi-lcd_fb0",},
+	return 0;
+}
+
+static const struct of_device_id sunxi_lcd_fb_module_match[] = {
+	{
+		.compatible = "allwinner,lcd-fb",
+	},
 	{},
 };
 
-int lcd_fb_suspend(struct device *dev)
+int sunxi_lcd_fb_module_suspend(struct device *dev)
 {
 	int i = 0;
 	int ret = 0;
-	struct lcd_fb_device *dispdev = NULL;
+	struct sunxi_lcd_fb_device *dispdev = NULL;
 
-	for (i = 0; i < SUPPORT_MAX_LCD; ++i) {
-		dispdev = lcd_fb_device_get(i);
+	for (i = 0; i < g_drv_info.lcd_panel_count; ++i) {
+		dispdev = sunxi_sunxi_lcd_fb_device_get(i);
 		if (dispdev)
 			ret = dispdev->disable(dispdev);
 	}
 	return ret;
 }
 
-int lcd_fb_resume(struct device *dev)
+int sunxi_lcd_fb_module_resume(struct device *dev)
 {
 	int i = 0;
 	int ret = 0;
-	struct lcd_fb_device *dispdev = NULL;
+	struct sunxi_lcd_fb_device *dispdev = NULL;
 
-	for (i = 0; i < SUPPORT_MAX_LCD; ++i) {
-		dispdev = lcd_fb_device_get(i);
+	for (i = 0; i < g_drv_info.lcd_panel_count; ++i) {
+		dispdev = sunxi_sunxi_lcd_fb_device_get(i);
 		if (dispdev)
 			ret = dispdev->enable(dispdev);
 	}
 	return ret;
 }
 
-static const struct dev_pm_ops lcd_fb_runtime_pm_ops = {
-	.suspend = lcd_fb_suspend,
-	.resume = lcd_fb_resume,
+static const struct dev_pm_ops sunxi_lcd_fb_module_runtime_pm_ops = {
+	.suspend = sunxi_lcd_fb_module_suspend,
+	.resume = sunxi_lcd_fb_module_resume,
 };
 
-struct platform_driver lcd_fb_driver = {
-	.probe = lcd_fb_probe,
-	.remove = lcd_fb_remove,
-	.shutdown = lcd_fb_shutdown,
+struct platform_driver sunxi_lcd_fb_driver = {
+	.probe = sunxi_lcd_fb_module_probe,
+	.remove = sunxi_lcd_fb_module_remove,
+	.shutdown = sunxi_lcd_fb_module_shutdown,
 	.driver = {
 		.name = "lcd_fb",
 		.owner = THIS_MODULE,
-		.pm             = &lcd_fb_runtime_pm_ops,
-		.of_match_table = lcd_fb_match,
+		.pm = &sunxi_lcd_fb_module_runtime_pm_ops,
+		.of_match_table = sunxi_lcd_fb_module_match,
 	},
 };
 
-static int __init lcd_fb_init(void)
+static int __init sunxi_lcd_fb_module_init(void)
 {
 	s32 ret = -1;
-	lcd_fb_wrn("\n");
-	ret = platform_driver_register(&lcd_fb_driver);
+	LCDFB_DBG("running sunxi_lcd_fb_module_init\n");
+	ret = platform_driver_register(&sunxi_lcd_fb_driver);
+
+	if (ret) {
+		LCDFB_WRN("lcd fb register driver failed!\n");
+		return ret;
+	}
+
 	return ret;
 }
 
-static void __exit lcd_fb_exit(void)
+static void __exit sunxi_lcd_fb_module_exit(void)
 {
-	platform_driver_unregister(&lcd_fb_driver);
-	lcd_fb_wrn("\n");
+	platform_driver_unregister(&sunxi_lcd_fb_driver);
+	LCDFB_HERE;
 }
 
-int sunxi_disp_get_source_ops(struct sunxi_disp_source_ops *src_ops)
+int sunxi_lcd_fb_disp_get_source_ops(
+	struct sunxi_lcd_fb_disp_source_ops *src_ops)
 {
 	memset((void *)src_ops, 0, sizeof(*src_ops));
 
-	src_ops->sunxi_lcd_set_panel_funs = bsp_disp_lcd_set_panel_funs;
-	src_ops->sunxi_lcd_delay_ms = disp_delay_ms;
-	src_ops->sunxi_lcd_delay_us = disp_delay_us;
-	src_ops->sunxi_lcd_backlight_enable = bsp_disp_lcd_backlight_enable;
-	src_ops->sunxi_lcd_backlight_disable = bsp_disp_lcd_backlight_disable;
-	src_ops->sunxi_lcd_pwm_enable = bsp_disp_lcd_pwm_enable;
-	src_ops->sunxi_lcd_pwm_disable = bsp_disp_lcd_pwm_disable;
-	src_ops->sunxi_lcd_power_enable = bsp_disp_lcd_power_enable;
-	src_ops->sunxi_lcd_power_disable = bsp_disp_lcd_power_disable;
-	src_ops->sunxi_lcd_pin_cfg = bsp_disp_lcd_pin_cfg;
-	src_ops->sunxi_lcd_gpio_set_value = bsp_disp_lcd_gpio_set_value;
-	src_ops->sunxi_lcd_gpio_set_direction = bsp_disp_lcd_gpio_set_direction;
-	src_ops->sunxi_lcd_cmd_write = bsp_disp_lcd_cmd_write;
-	src_ops->sunxi_lcd_para_write = bsp_disp_lcd_para_write;
-	src_ops->sunxi_lcd_cmd_read = bsp_disp_lcd_cmd_read;
+	src_ops->sunxi_lcd_fb_set_panel_funs_ops =
+		sunxi_lcd_fb_bsp_disp_lcd_set_panel_funs;
+	src_ops->sunxi_lcd_fb_delay_ms_ops = sunxi_lcd_fb_disp_delay_ms;
+	src_ops->sunxi_lcd_fb_delay_us_ops = sunxi_lcd_fb_disp_delay_us;
+	src_ops->sunxi_lcd_fb_backlight_enable_ops =
+		sunxi_lcd_fb_bsp_disp_lcd_backlight_enable;
+	src_ops->sunxi_lcd_fb_backlight_disable_ops =
+		sunxi_lcd_fb_bsp_disp_lcd_backlight_disable;
+	src_ops->sunxi_lcd_fb_pwm_enable_ops =
+		sunxi_lcd_fb_bsp_disp_lcd_pwm_enable;
+	src_ops->sunxi_lcd_fb_pwm_disable_ops =
+		sunxi_lcd_fb_bsp_disp_lcd_pwm_disable;
+	src_ops->sunxi_lcd_fb_power_enable_ops =
+		sunxi_lcd_fb_bsp_disp_lcd_power_enable;
+	src_ops->sunxi_lcd_fb_power_disable_ops =
+		sunxi_lcd_fb_bsp_disp_lcd_power_disable;
+	src_ops->sunxi_lcd_fb_pin_cfg_ops = sunxi_lcd_fb_bsp_disp_lcd_pin_cfg;
+	src_ops->sunxi_lcd_fb_gpio_set_value_ops =
+		sunxi_lcd_fb_bsp_disp_lcd_gpio_set_value;
+	src_ops->sunxi_lcd_fb_gpio_set_direction_ops =
+		sunxi_lcd_fb_bsp_disp_lcd_gpio_set_direction;
+	src_ops->sunxi_lcd_fb_cmd_write_ops =
+		sunxi_lcd_fb_bsp_disp_lcd_cmd_write;
+	src_ops->sunxi_lcd_fb_para_write_ops =
+		sunxi_lcd_fb_bsp_disp_lcd_para_write;
+	src_ops->sunxi_lcd_fb_cmd_read_ops = sunxi_lcd_fb_bsp_disp_lcd_cmd_read;
 	return 0;
 }
 
-module_init(lcd_fb_init);
-module_exit(lcd_fb_exit);
+module_init(sunxi_lcd_fb_module_init);
+module_exit(sunxi_lcd_fb_module_exit);
 
-MODULE_AUTHOR("te <zhengxiaobin@allwinnertech.com>");
-MODULE_DESCRIPTION("lcd fb module");
-MODULE_VERSION("1.0.0");
+MODULE_AUTHOR("zhengxiaobin <zhengxiaobin@allwinnertech.com>");
+MODULE_AUTHOR("zhangyuanjing <zhangyuanjing@allwinnertech.com>");
+MODULE_DESCRIPTION("sunxi lcd fb module");
+MODULE_VERSION("1.0.1");
 MODULE_LICENSE("GPL");
diff --git a/drivers/video/sunxi/lcd_fb/dev_lcd_fb.h b/drivers/video/sunxi/lcd_fb/dev_lcd_fb.h
index 38a752e69..883dcb1c0 100644
--- a/drivers/video/sunxi/lcd_fb/dev_lcd_fb.h
+++ b/drivers/video/sunxi/lcd_fb/dev_lcd_fb.h
@@ -1,4 +1,4 @@
-/* SPDX-License-Identifier: GPL-2.0-or-later */
+// SPDX-License-Identifier: GPL-2.0-or-later
 /* Copyright(c) 2020 - 2023 Allwinner Technology Co.,Ltd. All rights reserved. */
 /*
  * Copyright (c) 2007-2019 Allwinnertech Co., Ltd.
@@ -16,14 +16,16 @@
  */
 #ifndef _DEV_LCD_FB_H
 #define _DEV_LCD_FB_H
-#include "include.h"
 
-extern struct dev_lcd_fb_t g_drv_info;
+#include "include.h"
 
-struct dev_lcd_fb_t {
+struct sunxi_lcd_fb_dev_lcd_fb_t {
 	struct device *device;
 	struct work_struct start_work;
-	unsigned char lcd_fb_num;
+	u32 lcd_fb_num;
+	u32 lcd_panel_count;
 };
 
+extern struct sunxi_lcd_fb_dev_lcd_fb_t g_drv_info;
+
 #endif /* End of file */
